unit uMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, uCore;

type
  TfmMain = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    edtVal1: TEdit;
    edtVal2: TEdit;
    Label3: TLabel;
    btnAdd: TButton;
    btnMul: TButton;
    btnFact: TButton;
    medtRes: TMemo;
    btStatistics: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure btnMulClick(Sender: TObject);
    procedure btnFactClick(Sender: TObject);
    procedure btStatisticsClick(Sender: TObject);
  private
    Val1, Val2: TLargeNum;
    Res: TLargeNum;
    procedure ConvertToLargeNumbers();
  public
  end;

var
  fmMain: TfmMain;

implementation

uses uStatistics;

{$R *.DFM}

procedure TfmMain.ConvertToLargeNumbers;
begin
  Val1.AssignNumber(edtVal1.Text);
  Val2.AssignNumber(edtVal2.Text);
end;

procedure TfmMain.FormCreate(Sender: TObject);
begin
  Val1 := TLargeNum.Create(0);
  edtVal1.Text := Val1.ToString();

  Val2 := TLargeNum.Create(0);
  edtVal2.Text := Val2.ToString();
end;

procedure TfmMain.btnAddClick(Sender: TObject);
begin
  ConvertToLargeNumbers;
  Res := Val1.Add(Val2);
  medtRes.Lines.Clear();
  medtRes.Lines.Add(Res.ToString());
end;

procedure TfmMain.btnMulClick(Sender: TObject);
begin
  ConvertToLargeNumbers;
  Res := Val1.Mul(Val2);
  medtRes.Lines.Clear();
  medtRes.Lines.Add(Res.ToString());
end;

procedure TfmMain.btnFactClick(Sender: TObject);
begin
  ConvertToLargeNumbers;
//  Res := Val1.Fact2();
  Res := Val1.Fact();
  medtRes.Lines.Clear();
  medtRes.Lines.Add(Res.ToString());

end;

procedure TfmMain.btStatisticsClick(Sender: TObject);
var
  DlgStat : TdlgStatistics;
begin
  DlgStat := TdlgStatistics.Create(Self);
  DlgStat.ShowStatistics(Res);
  DlgStat.Free();
end;

end.
