unit uStatistics;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls,
  uCore;

const
  _wid = 200;

type
  TdlgStatistics = class(TForm)
    OKBtn: TButton;
    chExcludeLastZeroes: TCheckBox;
    cbDigit: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    lbCount: TLabel;
    Label3: TLabel;
    lbTotal: TLabel;
    procedure chExcludeLastZeroesClick(Sender: TObject);
    procedure cbDigitChange(Sender: TObject);
  private
    FNumber: TLargeNum;
    FNumberWOLZ: TLargeNum;
    DigFreq : array[0..9] of integer;
    Lbl : array[0..9] of TLabel;
    Leg : array[0..9] of TLabel;
    procedure CountStatistics(n: TLargeNum);
  public
    procedure AfterConstruction(); override;
    procedure ShowStatistics(n : TLargeNum);
  end;

implementation

{$R *.dfm}

{ TdlgStatistics }

procedure TdlgStatistics.AfterConstruction;
var
  i: integer;
  Lb: TLabel;
  ltop : integer;
begin
  inherited;
  for i := 0 to 9 do begin
    ltop := 10 + (i*20);
    Lbl[i] := TLabel.Create(Self);
    Lbl[i].Parent := Self;
    Lbl[i].Color := clGreen;
    Lbl[i].Left := 60;
    Lbl[i].Top := ltop;
    Lbl[i].Width := 30;

    Leg[i] := TLabel.Create(Self);
    Leg[i].Parent := Self;
    Leg[i].Left := 30;
    Leg[i].Top := ltop + 3;
    Leg[i].Caption := '0%';
    Leg[i].Font.Style := Leg[i].Font.Style + [fsBold];

    Lb := TLabel.Create(Self);
    Lb.Parent := Self;
    Lb.Caption := IntToStr(i)+ ':';
    Lb.Left := 10;
    Lb.Top := ltop + 3;
    Lb.Font.Style := Lb.Font.Style + [fsBold];

    cbDigit.ItemIndex := 0;

  end;
end;

procedure TdlgStatistics.CountStatistics(n: TLargeNum);
var
  idig : byte;
  j : integer;
  aLen : integer;
  ratio: double;
begin
  aLen := n.GetLen();
  for idig := 0 to 9 do begin
    DigFreq[idig] := 0;
    for j := 1 to aLen do
      if (n.GetDigit(j) = idig) then inc(DigFreq[idig]);
    ratio := DigFreq[idig]/aLen;
    Lbl[idig].Width := Round(ratio*_wid);
    Leg[idig].Caption := IntToStr(Round(ratio*100))+'%';

    lbCount.Caption := IntToStr(DigFreq[cbDigit.ItemIndex]);
    lbTotal.Caption := IntToStr(n.GetLen());
  end;
end;

procedure TdlgStatistics.ShowStatistics(n : TLargeNum);
begin
  FNumber := TLargeNum.Create(n);
  FNumberWOLZ := TLargeNum.Create(n);
  FNumberWOLZ.TruncZeroes();

  CountStatistics(FNumber);
  ShowModal();
end;

procedure TdlgStatistics.chExcludeLastZeroesClick(Sender: TObject);
begin
  if (not chExcludeLastZeroes.Checked)
    then CountStatistics(FNumber)
    else CountStatistics(FNumberWOLZ);
end;

procedure TdlgStatistics.cbDigitChange(Sender: TObject);
begin
  chExcludeLastZeroesClick(Sender);
end;

end.
